import numpy as np
import torch
import torchvision.transforms as transforms

class Dataset(torch.utils.data.Dataset):
	def __init__(self, data, gt, abnormality, transform):
		super(Dataset, self).__init__()
		self.data = data

		self.gt = gt 
		self.abnormality = abnormality
		self.len = data.size()[0]
		self.channel = data.size()[1]

		self.transform = transform

	def __len__(self):
		return self.len

	def __getitem__(self,index):
		data = self.data[index]
		gt = self.gt[index]
		abnormality = self.abnormality[index]

#		data = transforms.ToPILImage()(data)
#		data = self.transform(data)

		return index, data, gt, abnormality

